﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Schedule.Models;
using System.Linq.Dynamic;
using System.Linq.Expressions;
using System.Linq.Dynamic.Core;
using System.Collections;

// For more information on enabling Web API for empty projects, visit http://go.microsoft.com/fwlink/?LinkID=397860

namespace Schedule.Controllers
{
    [Route("api/[controller]")]
    public class OrdersController : Controller
    {
        private NORTHWNDContext _context;
        public OrdersController(NORTHWNDContext context)
        {
            _context = context;
        }
        // GET: api/values
        [HttpGet]

        public object Get()
        {
            List<Orders> dataSource = _context.Orders.ToList();
            var queryString = Request.Query;

            int skip = Convert.ToInt32(queryString["$skip"]);
            int take = Convert.ToInt32(queryString["$top"]);
            string sort = queryString["$orderby"];//sorting   
            string filter = queryString["$filter"];
            if (sort != null)
            {
                dataSource = dataSource.AsQueryable().OrderBy(sort).ToList();
            }
            if (filter != null)
            {
                int keys = filter.Split(new string[] { "'" }, StringSplitOptions.None).Count();
                if (keys > 1)
                {
                    string[] key1 = filter.Split(new string[] { "'" }, StringSplitOptions.None);
                    dataSource = dataSource.Where(p => p.CustomerID.StartsWith(key1[1].ToString())).ToList();
                }
                else
                {
                    string[] str = filter.Split(new string[] { " " }, StringSplitOptions.None);
                    var val = double.Parse(str[2]);
                    dataSource = dataSource.Where(fil => fil.EmployeeID == val || fil.OrderID == val).Distinct().ToList();
                }

            }
            if(skip>0)
            {
                dataSource = dataSource.Skip(skip).ToList();
           
            }
            if (take > 0)
            {
                dataSource = dataSource.Take(take).ToList();
            }
            var count = dataSource.Count;
            return new { Items = dataSource, Count = dataSource.Count() };
        }


        // POST api/values
        [HttpPost]
        public void Post([FromBody]string value)
        {
        }

        // PUT api/values/5
        [HttpPut("{id}")]
        public void Put(int id, [FromBody]string value)
        {
        }

        // DELETE api/values/5
        [HttpDelete("{id}")]
        public void Delete(int id)
        {
        }
    }
}
